function ConfigTest(A){TestCase.call(this,A)
}ConfigTest.inherits(TestCase);
ConfigTest.prototype.testBasic=function(){var A;
gadgets.config.register("testBasic",null,function(B){A=B.testBasic
});
gadgets.config.init({testBasic:{data:"Hello, World!"}});
this.assertEquals("Hello, World!",A.data)
};
ConfigTest.prototype.testMultiple=function(){var B;
gadgets.config.register("testMultiple",null,function(C){B=C.testMultiple
});
var A;
gadgets.config.register("testMultiple",null,function(C){A=C.testMultiple
});
gadgets.config.init({testMultiple:{data:"Hello, World!"}});
this.assertEquals("Hello, World!",B.data);
this.assertEquals("Hello, World!",A.data)
};
ConfigTest.prototype.testValidator=function(){var A;
gadgets.config.register("testValidator",{data:function(B){A=B;
return true
}});
gadgets.config.init({testValidator:{data:"Hello, World!"}});
this.assertEquals("Hello, World!",A)
};
ConfigTest.prototype.testValidatorMultiple=function(){var B;
gadgets.config.register("testValidator",{key0:function(C){B=C;
return true
}});
var A;
gadgets.config.register("testValidator",{key1:function(C){A=C;
return true
}});
gadgets.config.init({testValidator:{key0:"Hello, World!",key1:"Goodbye, World!"}});
this.assertEquals("Hello, World!",B);
this.assertEquals("Goodbye, World!",A)
};
ConfigTest.prototype.testValidatorRejection=function(){gadgets.config.register("testValidatorRejection",{data:function(B){return false
}});
try{gadgets.config.init({testValidatorRejection:{data:"Hello, World!"}});
this.fail("Did not throw an exception when validation failed.")
}catch(A){}};
ConfigTest.prototype.testValidatorDisabled=function(){var A;
gadgets.config.register("testValidatorDisabled",{data:function(B){return false
}},function(B){A=B.testValidatorDisabled
});
gadgets.config.init({testValidatorDisabled:{data:"Hello, World!"}},true);
this.assertEquals("Hello, World!",A.data)
};
ConfigTest.prototype.testEnumValidator=function(){var A=gadgets.config.EnumValidator("foo","bar","baz");
this.assertTrue(A("foo"));
this.assertTrue(A("bar"));
this.assertTrue(A("baz"));
this.assertFalse(A("junk"))
};
ConfigTest.prototype.testRegExValidator=function(){var A=gadgets.config.RegExValidator(/^hello.*$/);
this.assertTrue(A("hello"));
this.assertTrue(A("hello, world"));
this.assertTrue(A("hellothere"));
this.assertFalse(A("not hello"))
};
ConfigTest.prototype.testExistsValidator=function(){var A=gadgets.config.ExistsValidator;
this.assertTrue(A("hello"));
this.assertTrue(A(0));
this.assertTrue(A(false));
this.assertTrue(A(null));
this.assertTrue(A(""));
this.assertFalse(A({}.foo))
};
ConfigTest.prototype.testNonEmptyStringValidator=function(){var A=gadgets.config.NonEmptyStringValidator;
this.assertTrue(A("hello"));
this.assertFalse(A(0));
this.assertFalse(A(false));
this.assertFalse(A(null));
this.assertFalse(A(""));
this.assertFalse(A(undefined))
};
ConfigTest.prototype.testBooleanValidator=function(){var A=gadgets.config.BooleanValidator;
this.assertTrue(A(true));
this.assertTrue(A(false));
this.assertFalse(A("hello"));
this.assertFalse(A(0));
this.assertFalse(A(null));
this.assertFalse(A(undefined))
};
ConfigTest.prototype.testLikeValidator=function(){var B,A;
var C=gadgets.config.LikeValidator({key0:function(D){B=D;
return true
},key1:function(D){A=D;
return true
},});
this.assertTrue(C({key0:"Key0",key1:"Key1"}));
this.assertEquals("Key0",B);
this.assertEquals("Key1",A)
};
ConfigTest.prototype.testLikeValidatorWithFailure=function(){var B,A;
var C=gadgets.config.LikeValidator({key0:function(D){B=D;
return false
},key1:function(D){A=D;
return true
},});
this.assertFalse(C({key0:"Key0",key1:"Key1"}));
this.assertEquals("Key0",B);
this.assertEquals(null,A)
};