function SetPrefsTest(A){TestCase.call(this,A)
}SetPrefsTest.inherits(TestCase);
SetPrefsTest.prototype.setUp=function(){var A=this;
this.savedRpc=gadgets.rpc;
gadgets.rpc={};
gadgets.rpc.call=function(){A.rpcArguments=Array.prototype.slice.call(arguments)
}
};
SetPrefsTest.prototype.tearDown=function(){this.rpcArguments=undefined;
gadgets.rpc=this.savedRpc
};
SetPrefsTest.prototype.testSet=function(){var A=new gadgets.Prefs();
gadgets.Prefs.setInternal_("key",100);
A.set("key",200);
this.assertEquals(200,A.getInt("key"));
this.assertRpcCalled(null,"set_pref",null,0,"key",200)
};
SetPrefsTest.prototype.testSetArray=function(){var A=new gadgets.Prefs();
A.setArray("array",["foo","bar"]);
var B=A.getArray("array");
this.assertEquals(2,B.length);
this.assertEquals("foo",B[0]);
this.assertEquals("bar",B[1]);
this.assertRpcCalled(null,"set_pref",null,0,"array","foo|bar")
};
SetPrefsTest.prototype.testSetArrayWithPipe=function(){var A=new gadgets.Prefs();
A.setArray("array",["foo","b|ar"]);
var B=A.getArray("array");
this.assertEquals(2,B.length);
this.assertEquals("foo",B[0]);
this.assertEquals("b|ar",B[1]);
this.assertRpcCalled(null,"set_pref",null,0,"array","foo|b%7Car")
};
SetPrefsTest.prototype.testSetArrayWithNumbers=function(){var A=new gadgets.Prefs();
A.setArray("array",[1,2]);
var B=A.getArray("array");
this.assertEquals(2,B.length);
this.assertEquals("1",B[0]);
this.assertEquals("2",B[1]);
this.assertRpcCalled(null,"set_pref",null,0,"array","1|2")
};
SetPrefsTest.prototype.assertRpcCalled=function(){this.assertNotUndefined("RPC was not called.",this.rpcArguments);
this.assertEquals("RPC argument list not valid length.",arguments.length,this.rpcArguments.length);
for(var A=0;
A<arguments.length;
A++){this.assertEquals(arguments[A],this.rpcArguments[A])
}};